"""
Ouvrir une base de données
Afficher tous les attributs de toutes les tables
Effectuer une requête SQL pour récupérer des données

"""

import sqlite3

connecteur = sqlite3.connect("facturation.sqlite")
curseur = connecteur.cursor()

try :
    curseur.execute("SELECT name FROM sqlite_master WHERE type='table';")
    all_tables = curseur.fetchall()

    for one_table in all_tables : # pour chaque table de la base de données
        # Afficher le nom de la table
        print("======== Table : ",one_table,"=========")
        
        # Effectuer une requête sur la table
        curseur.execute("SELECT * FROM '"+one_table[0]+"';")

        # Afficher tous les champs de la table
        all_attributs = curseur.description
        print("=>( ",end='')
        for one_attribut in all_attributs :
            print(one_attribut[0],",",end='')
        print("\b)")


    # ======================================  Effectuer une requête simple SQL
    curseur.execute("SELECT COUNT(*) FROM CLIENTS")
    print(curseur.fetchall())

    # ======================================  Effectuer une requête simple SQL
    societe = "Godos Cocina Tipica"
    produit = "Louisiana Fiery Hot Pepper Sauce"

    curseur.execute( """SELECT Cde.DATE_COMMANDE, DCde.QUANTITE
    FROM
        COMMANDES as Cde INNER JOIN DETAILS_COMMANDES as DCde,
        PRODUITS as P,
        CLIENTS as C
    ON
        C.CODE_CLIENT=Cde.CODE_CLIENT 
        and DCde.NO_COMMANDE=Cde.NO_COMMANDE
        and DCde.REF_PRODUIT=P.REF_PRODUIT
    WHERE
        C.SOCIETE= ? and P.NOM_PRODUIT= ? """,(societe, produit))
    reponse = curseur.fetchall()

    print("La société "+societe+" a commandé :")
    for enreg in reponse :
        print(enreg[1],produit," le ", enreg[0])
except :
    print("Erreur d'exécution d'une requête SQL")
    connecteur.rollback() # annuler d'éventuelles mises à jour
finally :
    curseur.close()
